-- Example of a binary synchronous counter 
--  using FSM style

LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;
USE  IEEE.STD_LOGIC_ARITH.all;
USE  IEEE.STD_LOGIC_UNSIGNED.all;

ENTITY SQUARE_1HZ_DIVIDER IS
		PORT(	CD,CLK,CE	: 	IN  std_logic;
				TC100			:	OUT std_logic
		);

END SQUARE_1HZ_DIVIDER;

			-- Internal desciption in FSM style

ARCHITECTURE structural_design OF SQUARE_1HZ_DIVIDER IS

-- The elemental component to be used:

COMPONENT freq_div_50 IS
      Port (	
			CLK 	: IN	STD_LOGIC;
			CD 	: IN	STD_LOGIC;
			CE 	: IN	STD_LOGIC;
			TC50		: OUT	STD_LOGIC
		);

END COMPONENT;
 
 COMPONENT T_Flip_Flop IS
      Port (	
			CLK 	: IN	STD_LOGIC;
			CD 	: IN	STD_LOGIC;
			T 		: IN	STD_LOGIC;
			Q 		: OUT	STD_LOGIC
		);

END COMPONENT;
 
-- Signals
	SIGNAL	CE1			: STD_LOGIC;	
	-- output from the freq_div_50 is a pulsed 2 Hz signal which 
	-- has to be squared by the flip flop T
			
BEGIN  
-- Architecture not ready yet. This sentence is for nothing:

-- Instantiation of components:

	Chip1	: freq_div_50
		PORT MAP (
	-- from component name 	=> to signal or port name	
			CLK		=> CLK,
			CD 		=> CD,
			CE			=> CE,
			TC50	   => CE1				  
		);

	Chip2	: T_Flip_Flop
		PORT MAP (
	-- from component name 	=> to signal or port name	
			CLK		=> CLK,
			CD 		=> CD,
			T			=> CE1,
			Q	 		=> TC100				  
		);

-- Other circuits and equations:



END structural_design;






